//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var _ = Package.underscore._;
var check = Package.check.check;
var Match = Package.check.Match;
var OAuth = Package.oauth.OAuth;
var Oauth = Package.oauth.Oauth;
var Accounts = Package['accounts-base'].Accounts;

(function(){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                              //
// packages/barringer_accounts-login-only/login_only_client.js                                                  //
//                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                //
Accounts.oauth.tryLoginOnlyAfterPopupClosed = function(credentialToken, callback) {
  var credentialSecret = OAuth._retrieveCredentialSecret(credentialToken);
  Accounts.callLoginMethod({
    methodArguments: [{loginOnly: {
      credentialToken: credentialToken,
      credentialSecret: credentialSecret
    }}],
    userCallback: callback && function (err) {
      // Allow server to specify a specify subclass of errors. We should come
      // up with a more generic way to do this!
      if (err && err instanceof Meteor.Error &&
          err.error === Accounts.LoginCancelledError.numericError) {
        callback(new Accounts.LoginCancelledError(err.details));
      } else {
        callback(err);
      }
    }});
};

Accounts.oauth.loginOnlyCredentialRequestCompleteHandler = function(callback) {
  return function (credentialTokenOrError) {
    if(credentialTokenOrError && credentialTokenOrError instanceof Error) {
      callback && callback(credentialTokenOrError);
    } else {
      Accounts.oauth.tryLoginOnlyAfterPopupClosed(credentialTokenOrError, callback);
    }
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                              //
// packages/barringer_accounts-login-only/services/facebook.js                                                  //
//                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                //
if (Meteor.isClient) {
  Meteor.loginOnlyWithFacebook = function (options, callback) {
    // if (Meteor.isCordova) {
    //   if (!Package['btafel:accounts-facebook-cordova']) {
    //     throw new Meteor.Error(403, 'Please include btafel:accounts-facebook-cordova package or cordova-fb package')
    //   }
    // } else {
      if(!Package['accounts-facebook'] || !Package['facebook-oauth']) {
        throw new Meteor.Error(403, 'Please include accounts-facebook and facebook-oauth package or cordova-fb package')
      }
    // }

    if (!callback && typeof options === "function") {
      callback = options;
      options = null;
    }

    var credentialRequestCompleteCallback = Accounts.oauth.loginOnlyCredentialRequestCompleteHandler(callback);
    Package['facebook-oauth'].Facebook.requestCredential(options, credentialRequestCompleteCallback);
  };
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                              //
// packages/barringer_accounts-login-only/services/strava.js                                                    //
//                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                //
if (Meteor.isClient) {
  Meteor.loginOnlyWithStrava = function (options, callback) {
    if (!Package['barringer:strava']) {
      throw new Meteor.Error(403, 'Please include barringer:strava package')
    }

    if (! callback && typeof options === "function") {
      callback = options;
      options = null;
    }

	var credentialRequestCompleteCallback = Accounts.oauth.loginOnlyCredentialRequestCompleteHandler(callback);
    Package["barringer:strava"].Strava.requestCredential(options, credentialRequestCompleteCallback);
  };
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
Package._define("barringer:accounts-login-only");

})();
