//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var OAuth = Package.oauth.OAuth;
var Oauth = Package.oauth.Oauth;
var Template = Package['templating-runtime'].Template;
var Random = Package.random.Random;
var ServiceConfiguration = Package['service-configuration'].ServiceConfiguration;
var Blaze = Package.blaze.Blaze;
var UI = Package.blaze.UI;
var Handlebars = Package.blaze.Handlebars;
var Spacebars = Package.spacebars.Spacebars;
var HTML = Package.htmljs.HTML;

/* Package-scope variables */
var DropboxOAuth;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                 //
// packages/gcampax_dropbox-oauth/client/request-credential.js                                                     //
//                                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                   //
DropboxOAuth = {};

// Request dropbox credentials for the user
// @param options {optional}
// @param callback {Function} Callback function to call on
//   completion. Takes one argument, credentialToken on success, or Error on
//   error.
DropboxOAuth.requestCredential = function (options, callback) {
  // support both (options, callback) and (callback).
  if (!callback && typeof options === 'function') {
    callback = options;
    options = {};
  }

  var config = ServiceConfiguration.configurations.findOne({service: 'dropbox'});
  if (!config) {
    callback && callback(new ServiceConfiguration.ConfigError("Service not configured"));
    return;
  }

  var credentialToken = Random.secret();

  var loginStyle = OAuth._loginStyle('dropbox', config, options);

  var loginUrl =
        'https://www.dropbox.com/1/oauth2/authorize' +
        '?response_type=code' +
        '&client_id=' + config.clientId +
        '&redirect_uri=' + OAuth._redirectUri('dropbox', config, {}, {secure: true}) +
        '&state=' + OAuth._stateParam(loginStyle, credentialToken);
  loginUrl = loginUrl.replace('?close', '?close=true');

  OAuth.launchLogin({
    loginService: "dropbox",
    loginStyle: loginStyle,
    loginUrl: loginUrl,
    credentialRequestCompleteCallback: callback,
    credentialToken: credentialToken,
    popupOptions: { height: 600 }
  });
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                 //
// packages/gcampax_dropbox-oauth/client/template.configure-dialog.js                                              //
//                                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                   //

Template.__checkName("configureLoginServiceDialogForDropbox");
Template["configureLoginServiceDialogForDropbox"] = new Template("Template.configureLoginServiceDialogForDropbox", (function() {
  var view = this;
  return [ HTML.Raw("<p>\n    First, you'll need to register your app on dropbox. Follow these steps:\n  </p>\n  "), HTML.OL("\n    ", HTML.Raw('<li>\n      Visit <a href="https://www.dropbox.com/developers/apps/create?app_type_checked=api" target="_blank">https://www.dropbox.com/developers/apps/create?app_type_checked=api</a>\n    </li>'), "\n    ", HTML.LI("\n      Set Drop-ins domains to: ", HTML.SPAN({
    class: "url"
  }, Blaze.View("lookup:siteUrl", function() {
    return Spacebars.mustache(view.lookup("siteUrl"));
  })), "\n    "), "\n    ", HTML.LI("\n      Set Redirect URI(s) to: ", HTML.SPAN({
    class: "url"
  }, Blaze.View("lookup:siteUrl", function() {
    return Spacebars.mustache(view.lookup("siteUrl"));
  }), "_oauth/dropbox?"), ". Note the final\n      question mark.\n    "), "\n  ") ];
}));

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                 //
// packages/gcampax_dropbox-oauth/client/configure-dialog.js                                                       //
//                                                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                   //
Template.configureLoginServiceDialogForDropbox.siteUrl = function () {
    return Meteor.absoluteUrl();
};

Template.configureLoginServiceDialogForDropbox.fields = function () {
    return [
        { property: 'clientId', label: 'App ID' },
        { property: 'secret', label: 'Secret' }
    ];
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
Package._define("gcampax:dropbox-oauth", {
  DropboxOAuth: DropboxOAuth
});

})();
